/* eslint-disable react/prop-types */
import React from 'react';
import Link from './Link';
import FormikConnect from './FormikConnect';

// eslint-disable-next-line func-names
export var getCustomField = function getCustomField(_ref) {
  var item = _ref.item,
      key = _ref.key,
      displayLabel = _ref.displayLabel,
      lang = _ref.lang,
      rtl = _ref.rtl,
      customRenderField = _ref.customRenderField,
      customElements = _ref.customElements;
  var customFieldType = item.customFieldType,
      customElementName = item.customElementName,
      customElementProps = item.customElementProps;

  if (customFieldType === 'link') {
    return React.createElement(Link, { item: item, key: key, displayLabel: displayLabel });
  }
  if (customFieldType === 'customRenderField') {
    if (!customRenderField) {
      throw new Error('Missing customRenderField in your <DashboardApp />');
    }
    return React.createElement(
      FormikConnect,
      null,
      function (form) {
        return customRenderField({
          field: item,
          fieldKey: key,
          fieldLabel: displayLabel,
          lang: lang,
          rtl: rtl,
          form: form
        });
      }
    );
  }
  if (customFieldType === 'customElements') {
    if (!customElements) {
      throw new Error('Missing customElements in your <DashboardApp />');
    }
    if (!customElements[customElementName]) {
      throw new Error('Missing ' + customElementName + ' in customElements in your <DashboardApp />');
    }
    var Element = customElements[customElementName];
    return React.createElement(
      FormikConnect,
      null,
      function (form) {
        return React.createElement(Element, { field: item, fieldKey: key, fieldLabel: displayLabel, lang: lang, rtl: rtl, form: form, customElementProps: customElementProps });
      }
    );
  }
  // eslint-disable-next-line no-console
  console.error('customFieldType is not valid');
  return null;
};