'use strict';

exports.__esModule = true;
exports.getCustomField = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _FormikConnect = require('./FormikConnect');

var _FormikConnect2 = _interopRequireDefault(_FormikConnect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line func-names
var getCustomField = exports.getCustomField = function getCustomField(_ref) {
  var item = _ref.item,
      key = _ref.key,
      displayLabel = _ref.displayLabel,
      lang = _ref.lang,
      rtl = _ref.rtl,
      customRenderField = _ref.customRenderField,
      customElements = _ref.customElements;
  var customFieldType = item.customFieldType,
      customElementName = item.customElementName,
      customElementProps = item.customElementProps;

  if (customFieldType === 'link') {
    return _react2.default.createElement(_Link2.default, { item: item, key: key, displayLabel: displayLabel });
  }
  if (customFieldType === 'customRenderField') {
    if (!customRenderField) {
      throw new Error('Missing customRenderField in your <DashboardApp />');
    }
    return _react2.default.createElement(
      _FormikConnect2.default,
      null,
      function (form) {
        return customRenderField({
          field: item,
          fieldKey: key,
          fieldLabel: displayLabel,
          lang: lang,
          rtl: rtl,
          form: form
        });
      }
    );
  }
  if (customFieldType === 'customElements') {
    if (!customElements) {
      throw new Error('Missing customElements in your <DashboardApp />');
    }
    if (!customElements[customElementName]) {
      throw new Error('Missing ' + customElementName + ' in customElements in your <DashboardApp />');
    }
    var Element = customElements[customElementName];
    return _react2.default.createElement(
      _FormikConnect2.default,
      null,
      function (form) {
        return _react2.default.createElement(Element, { field: item, fieldKey: key, fieldLabel: displayLabel, lang: lang, rtl: rtl, form: form, customElementProps: customElementProps });
      }
    );
  }
  // eslint-disable-next-line no-console
  console.error('customFieldType is not valid');
  return null;
}; /* eslint-disable react/prop-types */