'use strict';

exports.__esModule = true;

var _validate = require('validate.js');

var getInitialValues = function getInitialValues() {
  var jsonSchema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var properties = jsonSchema.properties || {};
  var initialValues = {};
  Object.keys(properties).forEach(function (itemKey) {
    var item = properties[itemKey];
    var docDashboard = (0, _validate.getDeepObjectValue)(item, 'meta.0.dashboard.doc');
    if (docDashboard && docDashboard.initialValue) {
      initialValues[itemKey] = docDashboard.initialValue;
      if (docDashboard.initialValue === 'date-now') {
        initialValues[itemKey] = new Date().toISOString();
      }
    }
  });
  return initialValues;
};
exports.default = getInitialValues;
module.exports = exports['default'];